Name: readline
Version: 6.3
Release: 5
License: GPL-3.0-or-later
Summary: GNU readline
Url: https://tiswww.case.edu/php/chet/readline/rltop.html


Source0: ftp://ftp.gnu.org/gnu/readline/readline-%{version}.tar.gz
Source1: readline-make-svr4

Patch0: readline-fix-autoreconf.patch
Patch1: readline-termcap-lib.patch
Patch2: readline-os400-shlib-install.patch
Patch3: readline-os400-svr4-shobj-conf.patch

BuildRequires: ncurses-devel
BuildRequires: pase-build-tools

%description
The GNU Readline library provides a set of functions for use by applications
that allow users to edit command lines as they are typed in. Both Emacs and vi
editing modes are available. The Readline library includes additional functions
to maintain a list of previously-entered command lines, to recall and perhaps
reedit those lines, and perform csh-like history expansion on previous commands.


%package -n libreadline6
Summary: readline library
Provides: %{name} = %{version}-%{release}

%description -n libreadline6
The GNU Readline library provides a set of functions for use by applications
that allow users to edit command lines as they are typed in. Both Emacs and vi
editing modes are available. The Readline library includes additional functions
to maintain a list of previously-entered command lines, to recall and perhaps
reedit those lines, and perform csh-like history expansion on previous commands.


%package devel
Summary: readline development files
Requires: %{name} = %{version}-%{release}

%description devel
The GNU Readline library provides a set of functions for use by applications
that allow users to edit command lines as they are typed in. Both Emacs and vi
editing modes are available. The Readline library includes additional functions
to maintain a list of previously-entered command lines, to recall and perhaps
reedit those lines, and perform csh-like history expansion on previous commands.


%package doc
Summary: readline development files
Requires: %{name} = %{version}-%{release}

%description doc
The GNU Readline library provides a set of functions for use by applications
that allow users to edit command lines as they are typed in. Both Emacs and vi
editing modes are available. The Readline library includes additional functions
to maintain a list of previously-entered command lines, to recall and perhaps
reedit those lines, and perform csh-like history expansion on previous commands.

%prep
%setup -q

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

cp %SOURCE1 make-svr4

%build

# readline prefers libcurses over libncurses if found, so as a hack we
# set bash_cv_termcap_lib=libncurses to pre-cache the autoconf check

%configure \
  CFLAGS="$CFLAGS -I%{_includedir}/ncurses" \
  LDFLAGS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib" \
  bash_cv_termcap_lib=libncurses \
  --enable-shared \
  --disable-static \
  # end

# This is set to find make-svr4 to build the svr4-style libraries on IBM i
export PATH=$PATH:$PWD
%make_build

%install

%make_install

%files -n libreadline6
%defattr(-, qsys, *none)

%{_libdir}/libhistory.so.6
%{_libdir}/libreadline.so.6

%files doc
%defattr(-, qsys, *none)

%{_docdir}/readline/CHANGES
%{_docdir}/readline/INSTALL
%{_docdir}/readline/README

%{_infodir}/history.info*
%{_infodir}/readline.info*
%{_infodir}/rluserman.info*

%files devel
%defattr(-, qsys, *none)

%{_libdir}/libreadline.so
%{_libdir}/libhistory.so

%{_mandir}/man3/history.3*
%{_mandir}/man3/readline.3*

%{_includedir}/readline/chardefs.h
%{_includedir}/readline/history.h
%{_includedir}/readline/keymaps.h
%{_includedir}/readline/readline.h
%{_includedir}/readline/rlconf.h
%{_includedir}/readline/rlstdc.h
%{_includedir}/readline/rltypedefs.h
%{_includedir}/readline/tilde.h

%changelog
* Fri Jun 19 2020 Kevin Adler <kadler@us.ibm.com> - 6.3
- Create svr4-style libraries directly w/o -bexpfull

* Wed May 27 2020 Kevin Adler <kadler@us.ibm.com> - 6.3
- Use generic paths for man and info pages to allow for compression

* Wed Nov 27 2019 Kevin Adler <kadler@us.ibm.com> - 6.3
- Use SPDX license identifier
- Update URL to new home page
- Wrap descriptions at 80 columns

* Fri Sep 27 2019 Kevin Adler <kadler@us.ibm.com> - 6.3
- Fix export of libc functions due to -bexpfull usage

* Tue Mar 26 2019 Kevin Adler <kadler@us.ibm.com> - 6.3
- ibm-build-tools -> pase-build-tools

* Fri Sep 07 2018 - Kevin Adler <kadler@us.ibm.com>
- Build with ncurses instead of PASE libcurses

* Fri Jun 22 2018 - Jesse R. Gorzinski <jgorzins@us.ibm.com>
- Fix improper ownership in 'doc' subpackage

* Mon Mar 12 2018 - Kevin Adler <kadler@us.ibm.com>
- Add unshipped files

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- Add inter-package dependencies

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- svr4_shlib.sh -> svr4-shrlib

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Remove 64-bit GCC script workarounds
- OBJECT_MODE now always set by build and install macros

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Use auto dependency resolution instead of requiring pase-libs

* Fri Sep 15 2017 - Kevin Adler <kadler@us.ibm.com>
- Use -bexpfull to export internal readline variables needed by GDB
